Package org.apache.ignite.internal.processors.cache

## Class IgniteCacheOffheapManagerImpl

- java.lang.Object
- - org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManagerImpl

All Implemented Interfaces:
  `IgniteCacheOffheapManager`

Direct Known Subclasses:
  `GridCacheOffheapManager`

    public class IgniteCacheOffheapManagerImpl
    extends Object
    implements IgniteCacheOffheapManager

### Nested Class Summary

Nested Classes
`static class` `IgniteCacheOffheapManagerImpl.CacheDataStoreImpl`
`protected static class` `IgniteCacheOffheapManagerImpl.ExpiredKeyCacheObject` This entry key is used to indicate that an expired entry has already been deleted from PendingEntriesTree and doesn't need to participate in PendingEntriesTree cleanup again.

### Nested classes/interfaces inherited from interface org.apache.ignite.internal.processors.cache.IgniteCacheOffheapManager

`IgniteCacheOffheapManager.CacheDataStore, IgniteCacheOffheapManager.OffheapInvokeClosure`

### Field Summary

Fields
`protected GridSpinBusyLock` `busyLock`
`protected GridCacheSharedContext` `ctx`
`protected CacheGroupContext` `grp`
`protected IgniteLogger` `log`
`protected GridStripedLock` `partStoreLock`
`static int` `PRELOAD_SIZE_UNDER_CHECKPOINT_LOCK` The maximum number of entries that can be preloaded under checkpoint read lock.

### Constructor Summary

Constructors
`IgniteCacheOffheapManagerImpl()`

### Method Summary

All Methods Instance Methods Concrete Methods
`Iterable<IgniteCacheOffheapManager.CacheDataStore>` `cacheDataStores()`
`long` `cacheEntriesCount​(int cacheId)`
`long` `cacheEntriesCount​(int cacheId, boolean primary, boolean backup, AffinityTopologyVersion topVer)`
`long` `cacheEntriesCount​(int cacheId, int part)`
`<K,​V> GridCloseableIterator<javax.cache.Cache.Entry<K,​V>>` `cacheEntriesIterator​(GridCacheContext cctx, boolean primary, boolean backup, AffinityTopologyVersion topVer, boolean keepBinary, Boolean dataPageScanEnabled)`
`GridIterator<CacheDataRow>` `cacheIterator​(int cacheId, boolean primary, boolean backups, AffinityTopologyVersion topVer, Boolean dataPageScanEnabled)`
`GridCloseableIterator<KeyCacheObject>` `cacheKeysIterator​(int cacheId, int part)`
`GridIterator<CacheDataRow>` `cachePartitionIterator​(int cacheId, int part, Boolean dataPageScanEnabled)`
`void` `clearCache​(GridCacheContext cctx, boolean readers)` Clears offheap entries.
`void` `confirmPartitionStatesRestored()` Confirm that partition states are restored.
`boolean` `containsKey​(GridCacheMapEntry entry)` TODO: GG-10884, used on only from initialValue.
`IgniteCacheOffheapManager.CacheDataStore` `createCacheDataStore​(int p)`
`protected IgniteCacheOffheapManager.CacheDataStore` `createCacheDataStore0​(int p)`
`IgniteCacheOffheapManager.CacheDataStore` `dataStore​(@Nullable GridDhtLocalPartition part)`
`void` `destroyCacheDataStore​(IgniteCacheOffheapManager.CacheDataStore store)`
`protected void` `destroyCacheDataStore0​(IgniteCacheOffheapManager.CacheDataStore store)`
`@Nullable RootPage` `dropRootPageForIndex​(int cacheId, String idxName, int segment)` Dropping the root page of the index tree.
`boolean` `expire​(GridCacheContext cctx, IgniteInClosure2X<GridCacheEntryEx,​GridCacheVersion> c, int amount)`
`long` `expiredSize()` Gets the number of entries pending expire.
`@Nullable RootPage` `findRootPageForIndex​(int cacheId, String idxName, int segment)`
`GridAtomicLong` `globalRemoveId()`
`boolean` `hasEntriesPendingExpire​(int cacheId)` Checks if the cache has entries pending expire.
`protected @Nullable IgniteHistoricalIterator` `historicalIterator​(CachePartitionPartialCountersMap partCntrs, Set<Integer> missing)`
`protected void` `initDataStructures()`
`protected void` `initPendingTree​(GridCacheContext<?,​?> cctx)`
`void` `invoke​(GridCacheContext cctx, KeyCacheObject key, GridDhtLocalPartition part, IgniteCacheOffheapManager.OffheapInvokeClosure c)`
`long` `offHeapAllocatedSize()`
`void` `onCacheStarted​(GridCacheContext cctx)`
`void` `onKernalStop()` Callback on node stop.
`int` `onUndeploy​(ClassLoader ldr)`
`GridIterator<CacheDataRow>` `partitionIterator​(int part)`
`void` `preloadPartition​(int partId)` Preload a partition.
`void` `prepareToStop()` Prepare cache group to stop (due to cache destroy or cluster deactivate).
`@Nullable CacheDataRow` `read​(GridCacheContext cctx, KeyCacheObject key)`
`@Nullable CacheDataRow` `read​(GridCacheMapEntry entry)`
`IgniteRebalanceIterator` `rebalanceIterator​(IgniteDhtDemandedPartitionsMap parts, AffinityTopologyVersion topVer)`
`void` `remove​(GridCacheContext cctx, KeyCacheObject key, int partId, GridDhtLocalPartition part)`
`@Nullable RootPage` `renameRootPageForIndex​(int cacheId, String oldIdxName, String newIdxName, int segment)` Renaming the root page of the index tree.
`GridCloseableIterator<CacheDataRow>` `reservedIterator​(int part, AffinityTopologyVersion topVer)`
`void` `restorePartitionStates()` Pre-create partitions that resides in page memory or WAL and restores their state.
`long` `restoreStateOfPartition​(int p, @Nullable Integer recoveryState)` Pre-create single partition that resides in page memory or WAL and restores their state.
`ReuseList` `reuseListForIndex​(String idxName)`
`RootPage` `rootPageForIndex​(int cacheId, String idxName, int segment)`
`void` `start​(GridCacheSharedContext ctx, CacheGroupContext grp)`
`void` `stop()` Stop cache group (due to cache destroy or cluster deactivate).
`void` `stopCache​(int cacheId, boolean destroy)`
`void` `storeEntries​(GridDhtLocalPartition part, Iterator<GridCacheEntryInfo> infos, IgnitePredicateX<CacheDataRow> initPred)` Store entries.
`protected String` `treeName​(int p)`
`void` `update​(GridCacheContext cctx, KeyCacheObject key, CacheObject val, GridCacheVersion ver, long expireTime, GridDhtLocalPartition part, @Nullable CacheDataRow oldRow)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### PRELOAD_SIZE_UNDER_CHECKPOINT_LOCK

    public static final int PRELOAD_SIZE_UNDER_CHECKPOINT_LOCK

The maximum number of entries that can be preloaded under checkpoint read lock.

See Also:
  Constant Field Values

#### ctx

    protected GridCacheSharedContext ctx

#### grp

    protected CacheGroupContext grp

#### log

    protected IgniteLogger log

#### busyLock

    protected final GridSpinBusyLock busyLock

#### partStoreLock

    protected GridStripedLock partStoreLock

### Constructor Detail

#### IgniteCacheOffheapManagerImpl

    public IgniteCacheOffheapManagerImpl()

### Method Detail

#### globalRemoveId

    public GridAtomicLong globalRemoveId()

Specified by:
  `globalRemoveId` in interface `IgniteCacheOffheapManager`
Returns:
  Global remove ID counter.

#### start

    public void start​(GridCacheSharedContext ctx,
                      CacheGroupContext grp)
               throws IgniteCheckedException

Specified by:
  `start` in interface `IgniteCacheOffheapManager`
Parameters:
  `ctx` - Context.
  `grp` - Cache group.
Throws:
  `IgniteCheckedException` - If failed.

#### onCacheStarted

    public void onCacheStarted​(GridCacheContext cctx)
                        throws IgniteCheckedException

Specified by:
  `onCacheStarted` in interface `IgniteCacheOffheapManager`
Parameters:
  `cctx` - Cache context.
Throws:
  `IgniteCheckedException` - If failed.

#### initPendingTree

    protected void initPendingTree​(GridCacheContext<?,​?> cctx)
                            throws IgniteCheckedException

Parameters:
  `cctx` - Cache context.
Throws:
  `IgniteCheckedException` - If failed.

#### initDataStructures

    protected void initDataStructures()
                               throws IgniteCheckedException

Throws:
  `IgniteCheckedException` - If failed.

#### stopCache

    public void stopCache​(int cacheId,
                          boolean destroy)

Specified by:
  `stopCache` in interface `IgniteCacheOffheapManager`
Parameters:
  `cacheId` - Cache ID.
  `destroy` - Destroy data flag. Setting to `true` will remove all cache data.

#### stop

    public void stop()

Stop cache group (due to cache destroy or cluster deactivate).

Specified by:
  `stop` in interface `IgniteCacheOffheapManager`

#### restoreStateOfPartition

    public long restoreStateOfPartition​(int p,
                                        @Nullable
                                        @Nullable Integer recoveryState)
                                 throws IgniteCheckedException

Pre-create single partition that resides in page memory or WAL and restores their state.

Specified by:
  `restoreStateOfPartition` in interface `IgniteCacheOffheapManager`
Parameters:
  `p` - Partition id.
  `recoveryState` - Partition recovery state.
Returns:
  Processing time in millis.
Throws:
  `IgniteCheckedException` - If failed.

#### restorePartitionStates

    public void restorePartitionStates()
                                throws IgniteCheckedException

Pre-create partitions that resides in page memory or WAL and restores their state.

Specified by:
  `restorePartitionStates` in interface `IgniteCacheOffheapManager`
Throws:
  `IgniteCheckedException` - If failed.

#### confirmPartitionStatesRestored

    public void confirmPartitionStatesRestored()

Confirm that partition states are restored. This method should be called after restoring state of all partitions in group using `IgniteCacheOffheapManager.restoreStateOfPartition(int, Integer)`.

Specified by:
  `confirmPartitionStatesRestored` in interface `IgniteCacheOffheapManager`

#### onKernalStop

    public void onKernalStop()

Callback on node stop.

Specified by:
  `onKernalStop` in interface `IgniteCacheOffheapManager`

#### prepareToStop

    public void prepareToStop()

Prepare cache group to stop (due to cache destroy or cluster deactivate).

Specified by:
  `prepareToStop` in interface `IgniteCacheOffheapManager`

#### dataStore

    public IgniteCacheOffheapManager.CacheDataStore dataStore​(@Nullable
                                                              @Nullable GridDhtLocalPartition part)

Specified by:
  `dataStore` in interface `IgniteCacheOffheapManager`
Parameters:
  `part` - Local partition or `null` if a related cache group is `LOCAL`.
Returns:
  Cache data store associated with given partition or the cache data store for a `LOCAL` cache group.

#### cacheEntriesCount

    public long cacheEntriesCount​(int cacheId)

Specified by:
  `cacheEntriesCount` in interface `IgniteCacheOffheapManager`
Parameters:
  `cacheId` - Cache ID.
Returns:
  Number of entries.

#### preloadPartition

    public void preloadPartition​(int partId)
                          throws IgniteCheckedException

Preload a partition. Must be called under partition reservation for DHT caches.

Specified by:
  `preloadPartition` in interface `IgniteCacheOffheapManager`
Parameters:
  `partId` - Partition id.
Throws:
  `IgniteCheckedException` - If failed.

#### cacheEntriesCount

    public long cacheEntriesCount​(int cacheId,
                                  boolean primary,
                                  boolean backup,
                                  AffinityTopologyVersion topVer)

Specified by:
  `cacheEntriesCount` in interface `IgniteCacheOffheapManager`
Parameters:
  `cacheId` - Cache ID.
  `primary` - Primary entries flag.
  `backup` - Backup entries flag.
  `topVer` - Topology version.
Returns:
  Entries count.

#### cacheEntriesCount

    public long cacheEntriesCount​(int cacheId,
                                  int part)

Specified by:
  `cacheEntriesCount` in interface `IgniteCacheOffheapManager`
Parameters:
  `cacheId` - Cache ID.
  `part` - Partition.
Returns:
  Number of entries in given partition.

#### cacheDataStores

    public Iterable<IgniteCacheOffheapManager.CacheDataStore> cacheDataStores()

Specified by:
  `cacheDataStores` in interface `IgniteCacheOffheapManager`
Returns:
  Iterable over all existing cache data stores.

#### invoke

    public void invoke​(GridCacheContext cctx,
                       KeyCacheObject key,
                       GridDhtLocalPartition part,
                       IgniteCacheOffheapManager.OffheapInvokeClosure c)
                throws IgniteCheckedException

Specified by:
  `invoke` in interface `IgniteCacheOffheapManager`
Parameters:
  `cctx` - Cache context.
  `key` - Key.
  `part` - Partition.
  `c` - Tree update closure.
Throws:
  `IgniteCheckedException` - If failed.

#### update

    public void update​(GridCacheContext cctx,
                       KeyCacheObject key,
                       CacheObject val,
                       GridCacheVersion ver,
                       long expireTime,
                       GridDhtLocalPartition part,
                       @Nullable
                       @Nullable CacheDataRow oldRow)
                throws IgniteCheckedException

Specified by:
  `update` in interface `IgniteCacheOffheapManager`
Parameters:
  `cctx` - Cache context.
  `key` - Key.
  `val` - Value.
  `ver` - Version.
  `expireTime` - Expire time.
  `part` - Partition.
  `oldRow` - Old row if available.
Throws:
  `IgniteCheckedException` - If failed.

#### remove

    public void remove​(GridCacheContext cctx,
                       KeyCacheObject key,
                       int partId,
                       GridDhtLocalPartition part)
                throws IgniteCheckedException

Specified by:
  `remove` in interface `IgniteCacheOffheapManager`
Parameters:
  `cctx` - Cache context.
  `key` - Key.
  `partId` - Partition number.
  `part` - Partition.
Throws:
  `IgniteCheckedException` - If failed.

#### read

    @Nullable
    public @Nullable CacheDataRow read​(GridCacheMapEntry entry)
                                throws IgniteCheckedException

Specified by:
  `read` in interface `IgniteCacheOffheapManager`
Parameters:
  `entry` - Cache entry.
Returns:
  Cached row, if available, null otherwise.
Throws:
  `IgniteCheckedException` - If failed.

#### read

    @Nullable
    public @Nullable CacheDataRow read​(GridCacheContext cctx,
                                       KeyCacheObject key)
                                throws IgniteCheckedException

Specified by:
  `read` in interface `IgniteCacheOffheapManager`
Parameters:
  `cctx` - Cache context.
  `key` - Key.
Returns:
  Cached row, if available, null otherwise.
Throws:
  `IgniteCheckedException` - If failed.

#### containsKey

    public boolean containsKey​(GridCacheMapEntry entry)

TODO: GG-10884, used on only from initialValue.

Specified by:
  `containsKey` in interface `IgniteCacheOffheapManager`

#### clearCache

    public void clearCache​(GridCacheContext cctx,
                           boolean readers)

Clears offheap entries.

Specified by:
  `clearCache` in interface `IgniteCacheOffheapManager`
Parameters:
  `readers` - `True` to clear readers.
  `cctx` - Cache context.

#### onUndeploy

    public int onUndeploy​(ClassLoader ldr)

Specified by:
  `onUndeploy` in interface `IgniteCacheOffheapManager`
Parameters:
  `ldr` - Class loader.
Returns:
  Number of undeployed entries.

#### offHeapAllocatedSize

    public long offHeapAllocatedSize()

Specified by:
  `offHeapAllocatedSize` in interface `IgniteCacheOffheapManager`
Returns:
  Offheap allocated size.

#### cacheEntriesIterator

    public <K,​V> GridCloseableIterator<javax.cache.Cache.Entry<K,​V>> cacheEntriesIterator​(GridCacheContext cctx,
                                                                                                      boolean primary,
                                                                                                      boolean backup,
                                                                                                      AffinityTopologyVersion topVer,
                                                                                                      boolean keepBinary,
                                                                                                      Boolean dataPageScanEnabled)

Specified by:
  `cacheEntriesIterator` in interface `IgniteCacheOffheapManager`
Parameters:
  `cctx` - Cache context.
  `primary` - `True` if need to return primary entries.
  `backup` - `True` if need to return backup entries.
  `topVer` - Topology version.
  `keepBinary` - Keep binary flag.
  `dataPageScanEnabled` - Flag to enable data page scan.
Returns:
  Entries iterator.

#### cacheKeysIterator

    public GridCloseableIterator<KeyCacheObject> cacheKeysIterator​(int cacheId,
                                                                   int part)
                                                            throws IgniteCheckedException

Specified by:
  `cacheKeysIterator` in interface `IgniteCacheOffheapManager`
Parameters:
  `cacheId` - Cache ID.
  `part` - Partition.
Returns:
  Iterator.
Throws:
  `IgniteCheckedException` - If failed.

#### cacheIterator

    public GridIterator<CacheDataRow> cacheIterator​(int cacheId,
                                                    boolean primary,
                                                    boolean backups,
                                                    AffinityTopologyVersion topVer,
                                                    Boolean dataPageScanEnabled)

Specified by:
  `cacheIterator` in interface `IgniteCacheOffheapManager`
Parameters:
  `cacheId` - Cache ID.
  `primary` - Primary entries flag.
  `backups` - Backup entries flag.
  `topVer` - Topology version.
  `dataPageScanEnabled` - Flag to enable data page scan.
Returns:
  Rows iterator.

#### cachePartitionIterator

    public GridIterator<CacheDataRow> cachePartitionIterator​(int cacheId,
                                                             int part,
                                                             Boolean dataPageScanEnabled)

Specified by:
  `cachePartitionIterator` in interface `IgniteCacheOffheapManager`
Parameters:
  `cacheId` - Cache ID.
  `part` - Partition.
  `dataPageScanEnabled` - Flag to enable data page scan.
Returns:
  Partition data iterator.

#### partitionIterator

    public GridIterator<CacheDataRow> partitionIterator​(int part)

Specified by:
  `partitionIterator` in interface `IgniteCacheOffheapManager`
Parameters:
  `part` - Partition number.
Returns:
  Iterator for given partition.

#### rootPageForIndex

    public RootPage rootPageForIndex​(int cacheId,
                                     String idxName,
                                     int segment)
                              throws IgniteCheckedException

Specified by:
  `rootPageForIndex` in interface `IgniteCacheOffheapManager`
Parameters:
  `cacheId` - Cache ID.
  `idxName` - Index name.
  `segment` - Segment.
Returns:
  Root page for index tree.
Throws:
  `IgniteCheckedException` - If failed.

#### findRootPageForIndex

    @Nullable
    public @Nullable RootPage findRootPageForIndex​(int cacheId,
                                                   String idxName,
                                                   int segment)
                                            throws IgniteCheckedException

Specified by:
  `findRootPageForIndex` in interface `IgniteCacheOffheapManager`
Parameters:
  `cacheId` - Cache ID.
  `idxName` - Index name.
Throws:
  `IgniteCheckedException` - If failed.

#### dropRootPageForIndex

    @Nullable
    public @Nullable RootPage dropRootPageForIndex​(int cacheId,
                                                   String idxName,
                                                   int segment)
                                            throws IgniteCheckedException

Dropping the root page of the index tree.

Specified by:
  `dropRootPageForIndex` in interface `IgniteCacheOffheapManager`
Parameters:
  `cacheId` - Cache ID.
  `idxName` - Index name.
  `segment` - Segment index.
Returns:
  Dropped root page of the index tree.
Throws:
  `IgniteCheckedException` - If failed.

#### renameRootPageForIndex

    @Nullable
    public @Nullable RootPage renameRootPageForIndex​(int cacheId,
                                                     String oldIdxName,
                                                     String newIdxName,
                                                     int segment)
                                              throws IgniteCheckedException

Renaming the root page of the index tree.

Specified by:
  `renameRootPageForIndex` in interface `IgniteCacheOffheapManager`
Parameters:
  `cacheId` - Cache id.
  `oldIdxName` - Old name of the index tree.
  `newIdxName` - New name of the index tree.
  `segment` - Segment index.
Returns:
  Renamed root page of the index tree.
Throws:
  `IgniteCheckedException` - If failed.

#### reuseListForIndex

    public ReuseList reuseListForIndex​(String idxName)

Specified by:
  `reuseListForIndex` in interface `IgniteCacheOffheapManager`
Parameters:
  `idxName` - Index name.
Returns:
  Reuse list for index tree.

#### reservedIterator

    public GridCloseableIterator<CacheDataRow> reservedIterator​(int part,
                                                                AffinityTopologyVersion topVer)

Specified by:
  `reservedIterator` in interface `IgniteCacheOffheapManager`
Parameters:
  `part` - Partition number.
  `topVer` - Topology version.
Returns:
  Iterator for given partition that will reserve partition state until it is closed.

#### rebalanceIterator

    public IgniteRebalanceIterator rebalanceIterator​(IgniteDhtDemandedPartitionsMap parts,
                                                     AffinityTopologyVersion topVer)
                                              throws IgniteCheckedException

Specified by:
  `rebalanceIterator` in interface `IgniteCacheOffheapManager`
Parameters:
  `parts` - Partitions.
Returns:
  Partition data iterator.
Throws:
  `IgniteCheckedException` - If failed.

#### historicalIterator

    @Nullable
    protected @Nullable IgniteHistoricalIterator historicalIterator​(CachePartitionPartialCountersMap partCntrs,
                                                                    Set<Integer> missing)
                                                             throws IgniteCheckedException

Parameters:
  `partCntrs` - Partition counters map.
  `missing` - Set of partitions need to populate if partition is missing or failed to reserve.
Returns:
  Historical iterator.
Throws:
  `IgniteCheckedException` - If failed.

#### storeEntries

    public void storeEntries​(GridDhtLocalPartition part,
                             Iterator<GridCacheEntryInfo> infos,
                             IgnitePredicateX<CacheDataRow> initPred)
                      throws IgniteCheckedException

Store entries.

Specified by:
  `storeEntries` in interface `IgniteCacheOffheapManager`
Parameters:
  `part` - Local partition.
  `infos` - Entry infos.
  `initPred` - Applied to all created rows. Each row that not matches the predicate is removed.
Throws:
  `IgniteCheckedException` - If failed.

#### createCacheDataStore

    public final IgniteCacheOffheapManager.CacheDataStore createCacheDataStore​(int p)
                                                                        throws IgniteCheckedException

Specified by:
  `createCacheDataStore` in interface `IgniteCacheOffheapManager`
Parameters:
  `p` - Partition.
Returns:
  Data store.
Throws:
  `IgniteCheckedException` - If failed.

#### createCacheDataStore0

    protected IgniteCacheOffheapManager.CacheDataStore createCacheDataStore0​(int p)
                                                                      throws IgniteCheckedException

Parameters:
  `p` - Partition.
Returns:
  Cache data store.
Throws:
  `IgniteCheckedException` - If failed.

#### destroyCacheDataStore

    public final void destroyCacheDataStore​(IgniteCacheOffheapManager.CacheDataStore store)
                                     throws IgniteCheckedException

Specified by:
  `destroyCacheDataStore` in interface `IgniteCacheOffheapManager`
Parameters:
  `store` - Data store.
Throws:
  `IgniteCheckedException` - If failed.

#### destroyCacheDataStore0

    protected void destroyCacheDataStore0​(IgniteCacheOffheapManager.CacheDataStore store)
                                   throws IgniteCheckedException

Parameters:
  `store` - Cache data store.
Throws:
  `IgniteCheckedException` - If failed.

#### treeName

    protected final String treeName​(int p)

Parameters:
  `p` - Partition.
Returns:
  Tree name for given partition.

#### expire

    public boolean expire​(GridCacheContext cctx,
                          IgniteInClosure2X<GridCacheEntryEx,​GridCacheVersion> c,
                          int amount)
                   throws IgniteCheckedException

Specified by:
  `expire` in interface `IgniteCacheOffheapManager`
Parameters:
  `cctx` - Cache context.
  `c` - Closure.
  `amount` - Limit of processed entries by single call, `-1` for no limit.
Returns:
  `True` if unprocessed expired entries remains.
Throws:
  `IgniteCheckedException` - If failed.

#### expiredSize

    public long expiredSize()
                     throws IgniteCheckedException

Gets the number of entries pending expire.

Specified by:
  `expiredSize` in interface `IgniteCacheOffheapManager`
Returns:
  Number of pending entries.
Throws:
  `IgniteCheckedException` - If failed to get number of pending entries.

#### hasEntriesPendingExpire

    public boolean hasEntriesPendingExpire​(int cacheId)
                                    throws IgniteCheckedException

Checks if the cache has entries pending expire.

Specified by:
  `hasEntriesPendingExpire` in interface `IgniteCacheOffheapManager`
Returns:
  `True` if there are entries pending expire.
Throws:
  `IgniteCheckedException` - If failed to get number of pending entries.